@import 'breakpoint-sass/stylesheets/breakpoint';
@import 'node_modules/susy/sass/susy';
@import '../../styles/breakpoints';
@import '../../styles/colors';

$open-animation-duration: 0.5s;

@keyframes pulse {
  0% {
    box-shadow: 0 6px 3px 0 rgba($color-black, 0.2),
    inset 0 0 0 0 lighten($color-anakiwa, 10%);
    border-color: $color-tiara;
    transform: translateY(0);
  }
  75% {
    box-shadow: 0 6px 3px 0 rgba($color-black, 0.2),
    inset 0 0 0 0 lighten($color-anakiwa, 10%);
    border-color: $color-tiara;
    transform: translateY(0);
  }
  87% {
    box-shadow: 0 9px 6px 2px rgba($color-black, 0.15),
    inset 0 0 0 4px lighten($color-anakiwa, 10%);
    border-color: lighten($color-anakiwa, 10%);
    transform: translateY(-3px);
  }
  100% {
    box-shadow: 0 6px 3px 0 rgba($color-black, 0.2),
    inset 0 0 0 0 lighten($color-anakiwa, 10%);
    border-color: $color-tiara;
    transform: translateY(0);
  }
}
@keyframes pulse-after {
  0% {
    background-color: $color-deep-cerulean;
    transform: scale(1, 1);
  }
  75% {
    background-color: $color-deep-cerulean;
    transform: scale(1, 1);
  }
  87% {
    background-color: darken($color-deep-cerulean, 10%);
    transform: scale(1, 1.75);
  }
  100% {
    background-color: $color-deep-cerulean;
    transform: scale(1, 1);
  }
}
@keyframes firefox-has-a-bug {
  0% {
    background-color: #cccccc;
    transform: scale(1, 1);
  }
  100% {
    background-color: #cccccc;
    transform: scale(1, 1);
  }
}

.list-actions {
  @include container(960px);
  display: flex;
  justify-content: flex-end;
  z-index: 1;

  @include breakpoint($all-but-xl) {
    padding: 0 15px;
  }

  &__search {
    flex: 1;
    margin-right: 15px;

    @include breakpoint($small) {
      margin-right: 10px;
    }
  }

  &__select {
    position: relative;
  }

  &__select-reset {
    position: absolute;
    top: 51%;
    right: 30px;
    padding: 6px 5px 0;
    color: $color-deep-cerulean;
    font-size: 21px;
    transform: translateY(-50%);
    z-index: 16;
  }

  &__actions {
    margin-bottom: 10px;
    text-align: center;
  }

  $pulse-animation-duration: 5s;

  &__button {
    // There's a firefox bug where the pseudo animation hangs out after it's removed.
    // This not-animated thing seems to fix it.
    // https://gitlab.com/passit/passit-frontend/issues/89
    &--not-animated {
      animation: none;

      &:after {
        animation: firefox-has-a-bug $pulse-animation-duration infinite;
      }

      &:hover:after {
        animation: none;
      }
    }

    &--animated {
      margin-top: -4px;
      animation: pulse $pulse-animation-duration infinite;

      &:after {
        animation: pulse-after $pulse-animation-duration infinite;
      }

      &:hover {
        animation: initial;

        &:after {
          animation: initial;
        }
      }
    }

  }

  &__import-link {
    margin-top: 10px;
    font-size: 14px;

    @include breakpoint($small) {
      display: none;
    }
  }
}

.list-empty-state {
  padding-top: 40px;
  padding-bottom: 30px;

  @include breakpoint($small) {
    text-align: center;
    padding-top: 40px;
  }

  &__copy {
    @include span(9 of 12);

    @include breakpoint($all-small) {
      @include span(12 of 12);
    }
  }
}

$placeholder-height: 40vh;
@keyframes shine {
  0% {
    left: 0;
  }
  50% {
    left: 100%;
  }
  51% {
    left: $placeholder-height * -1;
  }
}

.list-placeholders {
  margin: -20px auto 0;
  z-index: -1;
  width: 100%;
  overflow: hidden;
  position: relative;
  height: $placeholder-height;

  &--empty {
    height: $placeholder-height + 10vh;

    .list-placeholder:first-child {
      margin-top: 0;
    }
  }

  &--loading {
    &::before {
      content: '';
      position: absolute;
      top: 0;
      bottom: 0;
      left: 0;
      width: $placeholder-height + 10vh;
      background-image: linear-gradient(90deg,
        transparent 0%,
        rgba($color-white, 0.8),
        transparent 100%
      );
      z-index: 1;
      animation: shine 2s linear infinite;
    }
  }

  &:after {
    content: '';
    position: absolute;
    bottom: 0;
    left: 0;
    right: 0;
    height: 300px;
    background-image: linear-gradient(0deg, rgba($color-white,1) 0%, rgba($color-white, 0) 100%);
  }
}

.list-placeholder {
  display: block;
  position: relative;
  margin-top: -1px;
  padding-top: 0;
  border-top: 1px solid #DDEEF0;
  border-bottom: 1px solid #DDEEF0;

  @include breakpoint($all-but-xl) {
    padding: 0 15px;
  }
  &:nth-child(2n+2) .list-placeholder__text--title {
    width: 300px;
    @include breakpoint($small) {
      width: 175px;
    }
  }
  &:nth-child(3n+3) .list-placeholder__text--title {
    width: 250px;
    @include breakpoint($small) {
      width: 125px;
    }
  }
  &:nth-child(4n+4) .list-placeholder__text--title {
    width: 275px;
    @include breakpoint($small) {
      width: 150px;
    }
  }

  &__heading {
    display: block;
    position: relative;
    max-width: 960px;
    margin: 0 auto;
  }

  &__title {
    margin: 2px 0 0;
    padding: 15px 0;
    font-size: 20px;
    font-weight: 600;
  }

  &__button {
    position: absolute;
    top: 5px;
    right: 0;
    cursor: default;
    box-shadow: 0 6px 3px 0 rgba(0, 0, 0, 0.1), inset 0 0 0 0 #EEFAFF;
  }

  &__text {
    display: inline-block;
    width: 200px;
    height: 9px;
    background-color: $color-botticelli;
    @include breakpoint($small) {
      width: 100px;
    }

    &--button {
      width: 60px;
    }
  }
}

.secret-list {
  margin: 20px auto;
}

.secret-list-item {
  display: block;
  position: relative;
  margin-top: -1px;
  padding-top: 0;
  border-top: 1px solid $color-botticelli;
  border-bottom: 1px solid $color-botticelli;
  box-shadow: inset 0 0 0 0 rgba($color-thunder, 0.2), inset 0 0 0 0 rgba($color-thunder, 0.2);
  transition: padding $open-animation-duration, background-color $open-animation-duration / 4, box-shadow $open-animation-duration;

  &:hover {
    background-color: #f0fdfc;
  }

  &--is-active {
    border: 0;
    padding: 15px 0 75px;
    background-color: $color-aqua-spring;
    box-shadow: inset 0 7px 8px -7px rgba($color-thunder, 0.2), inset 0 -7px 8px -7px rgba($color-thunder, 0.2);
    z-index: 10;

    &:hover {
      background-color: #f4fcf7;
    }
  }

  &--add-form {
    margin-bottom: -20px;
  }
}

.secret-form-component {
  display: block;
  height: 0;
  opacity: 0;
  transform: translateY(-40px);
  transition: transform $open-animation-duration, opacity $open-animation-duration;

  &--is-active {
    height: auto;
    margin-bottom: -75px;
    opacity: 1;
    transform: translateY(0);
    z-index: 10;
  }
}
